#ifndef __SYSTEM
#define __SYSTEM


// LCD display
#define LCD_PORT PORTC
#define LCD_DATA_BITS (0xf0)
#define LCD_E_BIT (1<<PC2)
#define LCD_RS_BIT (1<<PC0)
#define LCD_DDR DDRC

#define LCD_DATA_FIXED_BITS 0


// if statement Button Handling
#define		B1				(PINA&BIT0)  
#define		B2				(PINA&BIT1)
#define		B3				(PINA&BIT2)
#define		B4				(PINA&BIT3)
#define		B5				(PINA&BIT4)
#define		LIMIT1_SENSOR	(PIND&BIT2)	
#define		LIMIT2_SENSOR	(PIND&BIT3)	
#define		TOGGLE	(PIND&BIT4)	

// FIFO Button Handling
#define SW_PORT PORTA
#define SW_INPUT PINA
#define SW_DDR DDRA
#define SW_BITS ((1<<PA0)|(1<<PA1)|(1<<PA2)|(1<<PA3)|(1<<PA4))
#define SW_BIT_LO (1<<PA0)
#define SW_BIT_HI (1<<PA4)


// relay set an clear bit
#define 	RELAY_HIGH		PORTA |= BIT6
#define 	RELAY_LOW		PORTA &= ~BIT6	           


// key codes returned by get_key()
#define BUTTON_INC	1	// (KEY_UP)
#define BUTTON_PREV	2	// (KEY_LEFT)
#define BUTTON_MODE	4	// (KEY_END) MIDDLE
#define BUTTON_NEXT	8	// (KEY_RIGHT)
#define BUTTON_DEC	16	// (KEY_DOWN)



// screen positions for timer display
#define SROW_TIMER_A 0
#define SCOL_TIMER_A 3
#define SROW_TIMER_B 1
#define SCOL_TIMER_B 3


// screen positions for other stuff
#define SCOL_MODE 11		/* column for mode display (2-line) */


// user interface mode
#define UI_SET_A 0
#define UI_SET_B 1
#define UI_RUN 2

#define UI_NUM_MODES 3


// cursor modes
#define CUR_OFF 0
#define CUR_MIN 1
#define CUR_SEC 2
#define CUR_TENTH 3

#define TRUE 1
#define FALSE 0


//--------BIT Definition --------------------
#define   BIT0        0x00000001
#define   BIT1        0x00000002
#define   BIT2        0x00000004
#define   BIT3        0x00000008
#define   BIT4        0x00000010
#define   BIT5        0x00000020
#define   BIT6        0x00000040
#define   BIT7        0x00000080
#define   BIT8        0x00000100
#define   BIT9        0x00000200
#define   BIT10       0x00000400
#define   BIT11       0x00000800
#define   BIT12       0x00001000
#define   BIT13       0x00002000
#define   BIT14       0x00004000
#define   BIT15       0x00008000
#define   BIT16       0x00010000
#define   BIT17       0x00020000
#define   BIT18       0x00040000
#define   BIT19       0x00080000
#define   BIT20       0x00100000
#define   BIT21       0x00200000
#define   BIT22       0x00400000
#define   BIT23       0x00800000
#define   BIT24       0x01000000
#define   BIT25       0x02000000
#define   BIT26       0x04000000
#define   BIT27       0x08000000
#define   BIT28       0x10000000
#define   BIT29       0x20000000
#define   BIT30       0x40000000
#define   BIT31       0x80000000

//--------Initialize Ports ------------------------
void ports_init(void);

//--------Initialize Timers -----------------------
void hwtimers_init(void);

//--------Initialize Uart interface ---------------
void uart1_init(void);
void uart1_send_char(unsigned char ch);
unsigned char uart1_receive_char(void);
unsigned char uart1_receive_char_nonstop(void);

//---------Buzzer --------------------------------- 
void buzzer(void);


#endif


